import edu.neu.ccs.demeter.*;
 class CopyVisitor extends UniversalVisitor {
  public CopyVisitor() {
    super();
    }
  
    private java.util.Stack history = new java.util.Stack();
    public CopyVisitor(Class firstClass) {
      try {
        history.push(firstClass.newInstance());
      } catch(Exception e) {
        e.printStackTrace();
      }
    }
  
  public Object get_copy() { return history.peek();   }
   Object get_return_val() { return get_copy() ;   }
  public void before_tree(Example source, Tree dest) {
    Example it = (Example) history.peek();
    Tree p = new Tree();
    it.set_tree(p);
    history.push(p);
    }
  public void after_tree(Example source, Tree dest) {
    history.pop();
    }
  public void before_l(Tree source, Label dest) {
    Tree it = (Tree) history.peek();
    Label p = new Label();
    it.set_l(p);
    history.push(p);
    }
  public void after_l(Tree source, Label dest) {
    history.pop();
    }
  public void before_left(Tree source, Tree dest) {
    Tree it = (Tree) history.peek();
    Tree p = new Tree();
    it.set_left(p);
    history.push(p);
    }
  public void after_left(Tree source, Tree dest) {
    history.pop();
    }
  public void before_right(Tree source, Tree dest) {
    Tree it = (Tree) history.peek();
    Tree p = new Tree();
    it.set_right(p);
    history.push(p);
    }
  public void after_right(Tree source, Tree dest) {
    history.pop();
    }
  public void before_v(Label source, int dest) {
    Label it = (Label) history.peek();
    it.set_v(dest);
    }
  public void before_total(SummingVisitor source, int dest) {
    SummingVisitor it = (SummingVisitor) history.peek();
    it.set_total(dest);
    }
  public void before_total(SummingVisitor2 source, int dest) {
    SummingVisitor2 it = (SummingVisitor2) history.peek();
    it.set_total(dest);
    }
  public void before_indent(PrintVisitor source, int dest) {
    PrintVisitor it = (PrintVisitor) history.peek();
    it.set_indent(dest);
    }
  public void before_needSpace(PrintVisitor source, boolean dest) {
    PrintVisitor it = (PrintVisitor) history.peek();
    it.set_needSpace(dest);
    }
  public void before_is_equal(SubgraphVisitor source, boolean dest) {
    SubgraphVisitor it = (SubgraphVisitor) history.peek();
    it.set_is_equal(dest);
    }
  public void before_is_equal(EqualVisitor source, boolean dest) {
    EqualVisitor it = (EqualVisitor) history.peek();
    it.set_is_equal(dest);
    }
  public void before_indent(DisplayVisitor source, int dest) {
    DisplayVisitor it = (DisplayVisitor) history.peek();
    it.set_indent(dest);
    }
  public void before_indent(TraceVisitor source, int dest) {
    TraceVisitor it = (TraceVisitor) history.peek();
    it.set_indent(dest);
    }
    void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
  }

    void universal_trv0_aft(UniversalVisitor _v_) {
    super.universal_trv0_aft(_v_);
  }

    void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    Object copy = get_copy();
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

}
