import edu.neu.ccs.demeter.*;
 class DisplayVisitor extends UniversalVisitor {
  protected int indent;
  public int get_indent() { return indent;   }
  public void set_indent(int new_indent) { indent = new_indent;   }
  public DisplayVisitor() { super();   }
  public DisplayVisitor(int indent) {
    super();
    set_indent(indent);
    }
  
    protected java.io.PrintWriter out = new java.io.PrintWriter(System.out, true);
    java.io.PrintWriter get_out()             { return out; }
    void set_out(java.io.PrintWriter new_out) { out = new_out; }
    DisplayVisitor(java.io.PrintWriter out)     { set_out(out); }
    DisplayVisitor(java.io.PrintStream out)
      { set_out(new java.io.PrintWriter(out, true)); }
  
  public void finish() { out.flush();   }
  public void before(Example host) {
    out.print(": Example  (");
    indent++;
    }
  public void after(Example host) {
    out.print(" )");
    indent--;
    }
  public void before_tree(Example source, Tree dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<tree> ");
    }
  public void before(Tree host) {
    out.print(": Tree  (");
    indent++;
    }
  public void after(Tree host) {
    out.print(" )");
    indent--;
    }
  public void before_l(Tree source, Label dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<l> ");
    }
  public void before_left(Tree source, Tree dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<left> ");
    }
  public void before_right(Tree source, Tree dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<right> ");
    }
  public void before(Label host) {
    out.print(": Label  (");
    indent++;
    }
  public void after(Label host) {
    out.print(" )");
    indent--;
    }
  public void before_v(Label source, int dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<v> ");
    out.print(" : int \"" + dest + "\"");
    }
  public void before(SummingVisitor host) {
    out.print(": SummingVisitor  (");
    indent++;
    }
  public void after(SummingVisitor host) {
    out.print(" )");
    indent--;
    }
  public void before_total(SummingVisitor source, int dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<total> ");
    out.print(" : int \"" + dest + "\"");
    }
  public void before(SummingVisitor2 host) {
    out.print(": SummingVisitor2  (");
    indent++;
    }
  public void after(SummingVisitor2 host) {
    out.print(" )");
    indent--;
    }
  public void before_total(SummingVisitor2 source, int dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<total> ");
    out.print(" : int \"" + dest + "\"");
    }
  public void before(Main host) {
    out.print(": Main  (");
    indent++;
    }
  public void after(Main host) {
    out.print(" )");
    indent--;
    }
  public void before(PrintVisitor host) {
    out.print(": PrintVisitor  (");
    indent++;
    }
  public void after(PrintVisitor host) {
    out.print(" )");
    indent--;
    }
  public void before_indent(PrintVisitor source, int dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<indent> ");
    out.print(" : int \"" + dest + "\"");
    }
  public void before_needSpace(PrintVisitor source, boolean dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<needSpace> ");
    out.print(" : boolean \"" + dest + "\"");
    }
  public void before(CopyVisitor host) {
    out.print(": CopyVisitor  (");
    indent++;
    }
  public void after(CopyVisitor host) {
    out.print(" )");
    indent--;
    }
  public void before_copy(CopyVisitor source, Object dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<copy> ");
    }
  public void before(SubgraphVisitor host) {
    out.print(": SubgraphVisitor  (");
    indent++;
    }
  public void after(SubgraphVisitor host) {
    out.print(" )");
    indent--;
    }
  public void before_is_equal(SubgraphVisitor source, boolean dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<is_equal> ");
    out.print(" : boolean \"" + dest + "\"");
    }
  public void before(EqualVisitor host) {
    out.print(": EqualVisitor  (");
    indent++;
    }
  public void after(EqualVisitor host) {
    out.print(" )");
    indent--;
    }
  public void before_is_equal(EqualVisitor source, boolean dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<is_equal> ");
    out.print(" : boolean \"" + dest + "\"");
    }
  public void before(DisplayVisitor host) {
    out.print(": DisplayVisitor  (");
    indent++;
    }
  public void after(DisplayVisitor host) {
    out.print(" )");
    indent--;
    }
  public void before_indent(DisplayVisitor source, int dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<indent> ");
    out.print(" : int \"" + dest + "\"");
    }
  public void before(TraceVisitor host) {
    out.print(": TraceVisitor  (");
    indent++;
    }
  public void after(TraceVisitor host) {
    out.print(" )");
    indent--;
    }
  public void before_indent(TraceVisitor source, int dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<indent> ");
    out.print(" : int \"" + dest + "\"");
    }
    void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
  }

    void universal_trv0_aft(UniversalVisitor _v_) {
    super.universal_trv0_aft(_v_);
  }

    void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

}
