import edu.neu.ccs.demeter.*;
 class TraceVisitor extends UniversalVisitor {
  protected int indent;
  public int get_indent() { return indent;   }
  public void set_indent(int new_indent) { indent = new_indent;   }
  public TraceVisitor() { super();   }
  public TraceVisitor(int indent) {
    super();
    set_indent(indent);
    }
  
    protected java.io.PrintWriter out = new java.io.PrintWriter(System.out, true);
    java.io.PrintWriter get_out()             { return out; }
    void set_out(java.io.PrintWriter new_out) { out = new_out; }
    TraceVisitor(java.io.PrintWriter out)     { set_out(out); }
    TraceVisitor(java.io.PrintStream out)
      { set_out(new java.io.PrintWriter(out, true)); }
  
  public void finish() { out.flush();   }
  public void before(Example host) {
    out.println("before Example");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Example host) {
    out.println("after Example");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_tree(Example source, Tree dest) {
    out.println("before -> Example, tree, Tree ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_tree(Example source, Tree dest) {
    out.println("after -> Example, tree, Tree ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Tree host) {
    out.println("before Tree");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Tree host) {
    out.println("after Tree");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_l(Tree source, Label dest) {
    out.println("before -> Tree, l, Label ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_l(Tree source, Label dest) {
    out.println("after -> Tree, l, Label ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_left(Tree source, Tree dest) {
    out.println("before -> Tree, left, Tree ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_left(Tree source, Tree dest) {
    out.println("after -> Tree, left, Tree ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_right(Tree source, Tree dest) {
    out.println("before -> Tree, right, Tree ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_right(Tree source, Tree dest) {
    out.println("after -> Tree, right, Tree ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Label host) {
    out.println("before Label");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Label host) {
    out.println("after Label");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_v(Label source, int dest) {
    out.println("before -> Label, v, int ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_v(Label source, int dest) {
    out.println("after -> Label, v, int ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(SummingVisitor host) {
    out.println("before SummingVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(SummingVisitor host) {
    out.println("after SummingVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_total(SummingVisitor source, int dest) {
    out.println("before -> SummingVisitor, total, int ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_total(SummingVisitor source, int dest) {
    out.println("after -> SummingVisitor, total, int ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(SummingVisitor2 host) {
    out.println("before SummingVisitor2");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(SummingVisitor2 host) {
    out.println("after SummingVisitor2");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_total(SummingVisitor2 source, int dest) {
    out.println("before -> SummingVisitor2, total, int ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_total(SummingVisitor2 source, int dest) {
    out.println("after -> SummingVisitor2, total, int ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Main host) {
    out.println("before Main");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Main host) {
    out.println("after Main");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(PrintVisitor host) {
    out.println("before PrintVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(PrintVisitor host) {
    out.println("after PrintVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_indent(PrintVisitor source, int dest) {
    out.println("before -> PrintVisitor, indent, int ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_indent(PrintVisitor source, int dest) {
    out.println("after -> PrintVisitor, indent, int ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_needSpace(PrintVisitor source, boolean dest) {
    out.println("before -> PrintVisitor, needSpace, boolean ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_needSpace(PrintVisitor source, boolean dest) {
    out.println("after -> PrintVisitor, needSpace, boolean ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(CopyVisitor host) {
    out.println("before CopyVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(CopyVisitor host) {
    out.println("after CopyVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_copy(CopyVisitor source, Object dest) {
    out.println("before -> CopyVisitor, copy, Object ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_copy(CopyVisitor source, Object dest) {
    out.println("after -> CopyVisitor, copy, Object ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(SubgraphVisitor host) {
    out.println("before SubgraphVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(SubgraphVisitor host) {
    out.println("after SubgraphVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_is_equal(SubgraphVisitor source, boolean dest) {
    out.println("before -> SubgraphVisitor, is_equal, boolean ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_is_equal(SubgraphVisitor source, boolean dest) {
    out.println("after -> SubgraphVisitor, is_equal, boolean ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(EqualVisitor host) {
    out.println("before EqualVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(EqualVisitor host) {
    out.println("after EqualVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_is_equal(EqualVisitor source, boolean dest) {
    out.println("before -> EqualVisitor, is_equal, boolean ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_is_equal(EqualVisitor source, boolean dest) {
    out.println("after -> EqualVisitor, is_equal, boolean ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(DisplayVisitor host) {
    out.println("before DisplayVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(DisplayVisitor host) {
    out.println("after DisplayVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_indent(DisplayVisitor source, int dest) {
    out.println("before -> DisplayVisitor, indent, int ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_indent(DisplayVisitor source, int dest) {
    out.println("after -> DisplayVisitor, indent, int ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(TraceVisitor host) {
    out.println("before TraceVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(TraceVisitor host) {
    out.println("after TraceVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_indent(TraceVisitor source, int dest) {
    out.println("before -> TraceVisitor, indent, int ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_indent(TraceVisitor source, int dest) {
    out.println("after -> TraceVisitor, indent, int ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(UniversalVisitor host) {
    out.println("before UniversalVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(UniversalVisitor host) {
    out.println("after UniversalVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
    void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
  }

    void universal_trv0_aft(UniversalVisitor _v_) {
    super.universal_trv0_aft(_v_);
  }

    void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

}
