import edu.neu.ccs.demeter.*;
 class CopyVisitor extends UniversalVisitor {
  public CopyVisitor() {
    super();
    }
  
    private java.util.Stack history = new java.util.Stack();
    public CopyVisitor(Class firstClass) {
      try {
        history.push(firstClass.newInstance());
      } catch(Exception e) {
        e.printStackTrace();
      }
    }
  
  public Object get_copy() { return history.peek();   }
   Object get_return_val() { return get_copy() ;   }
  public void before_first(Cd_graph source, Adj dest) {
    Cd_graph it = (Cd_graph) history.peek();
    Adj p = new Adj();
    it.set_first(p);
    history.push(p);
    }
  public void after_first(Cd_graph source, Adj dest) {
    history.pop();
    }
  public void before_rest(Cd_graph source, Adj_list dest) {
    Cd_graph it = (Cd_graph) history.peek();
    Class c = dest.getClass();
    Object p = null;
    try {
      p = c.newInstance();
    } catch(Exception e) {
      e.printStackTrace();
    }
    it.set_rest((Adj_list) p);
    history.push(p);
    }
  public void after_rest(Cd_graph source, Adj_list dest) {
    history.pop();
    }
  public void before_vertex(Adj source, Vertex dest) {
    Adj it = (Adj) history.peek();
    Vertex p = new Vertex();
    it.set_vertex(p);
    history.push(p);
    }
  public void after_vertex(Adj source, Vertex dest) {
    history.pop();
    }
  public void before_ns(Adj source, Neighbors dest) {
    Adj it = (Adj) history.peek();
    Class c = dest.getClass();
    Object p = null;
    try {
      p = c.newInstance();
    } catch(Exception e) {
      e.printStackTrace();
    }
    it.set_ns((Neighbors) p);
    history.push(p);
    }
  public void after_ns(Adj source, Neighbors dest) {
    history.pop();
    }
  public void before_c_ns(Construct source, Any_vertex_list dest) {
    Construct it = (Construct) history.peek();
    Class c = dest.getClass();
    Object p = null;
    try {
      p = c.newInstance();
    } catch(Exception e) {
      e.printStackTrace();
    }
    it.set_c_ns((Any_vertex_list) p);
    history.push(p);
    }
  public void after_c_ns(Construct source, Any_vertex_list dest) {
    history.pop();
    }
  public void before_first(Alternat source, Vertex dest) {
    Alternat it = (Alternat) history.peek();
    Vertex p = new Vertex();
    it.set_first(p);
    history.push(p);
    }
  public void after_first(Alternat source, Vertex dest) {
    history.pop();
    }
  public void before_second(Alternat source, Vertex dest) {
    Alternat it = (Alternat) history.peek();
    Vertex p = new Vertex();
    it.set_second(p);
    history.push(p);
    }
  public void after_second(Alternat source, Vertex dest) {
    history.pop();
    }
  public void before_string(Syntax_vertex source, String dest) {
    Syntax_vertex it = (Syntax_vertex) history.peek();
    it.set_string(dest);
    }
  public void before_label_name(Labeled_vertex source, Ident dest) {
    Labeled_vertex it = (Labeled_vertex) history.peek();
    it.set_label_name(dest);
    }
  public void before_class_name(Labeled_vertex source, Vertex dest) {
    Labeled_vertex it = (Labeled_vertex) history.peek();
    Vertex p = new Vertex();
    it.set_class_name(p);
    history.push(p);
    }
  public void after_class_name(Labeled_vertex source, Vertex dest) {
    history.pop();
    }
  public void before_first(Nany_vertex_list source, Any_vertex dest) {
    Nany_vertex_list it = (Nany_vertex_list) history.peek();
    Class c = dest.getClass();
    Object p = null;
    try {
      p = c.newInstance();
    } catch(Exception e) {
      e.printStackTrace();
    }
    it.set_first((Any_vertex) p);
    history.push(p);
    }
  public void after_first(Nany_vertex_list source, Any_vertex dest) {
    history.pop();
    }
  public void before_rest(Nany_vertex_list source, Any_vertex_list dest) {
    Nany_vertex_list it = (Nany_vertex_list) history.peek();
    Class c = dest.getClass();
    Object p = null;
    try {
      p = c.newInstance();
    } catch(Exception e) {
      e.printStackTrace();
    }
    it.set_rest((Any_vertex_list) p);
    history.push(p);
    }
  public void after_rest(Nany_vertex_list source, Any_vertex_list dest) {
    history.pop();
    }
  public void before_name(Vertex source, Ident dest) {
    Vertex it = (Vertex) history.peek();
    it.set_name(dest);
    }
  public void before_total(CountingVisitor source, int dest) {
    CountingVisitor it = (CountingVisitor) history.peek();
    it.set_total(dest);
    }
  public void before_indent(PrintVisitor source, int dest) {
    PrintVisitor it = (PrintVisitor) history.peek();
    it.set_indent(dest);
    }
  public void before_needSpace(PrintVisitor source, boolean dest) {
    PrintVisitor it = (PrintVisitor) history.peek();
    it.set_needSpace(dest);
    }
  public void before_is_equal(SubgraphVisitor source, boolean dest) {
    SubgraphVisitor it = (SubgraphVisitor) history.peek();
    it.set_is_equal(dest);
    }
  public void before_is_equal(EqualVisitor source, boolean dest) {
    EqualVisitor it = (EqualVisitor) history.peek();
    it.set_is_equal(dest);
    }
  public void before_indent(DisplayVisitor source, int dest) {
    DisplayVisitor it = (DisplayVisitor) history.peek();
    it.set_indent(dest);
    }
  public void before_indent(TraceVisitor source, int dest) {
    TraceVisitor it = (TraceVisitor) history.peek();
    it.set_indent(dest);
    }
    void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
  }

    void universal_trv0_aft(UniversalVisitor _v_) {
    super.universal_trv0_aft(_v_);
  }

    void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    Object copy = get_copy();
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

}
