import edu.neu.ccs.demeter.*;
 class CountingVisitor extends UniversalVisitor {
  protected int total;
  public int get_total() { return total;   }
  public void set_total(int new_total) { total = new_total;   }
  public CountingVisitor(int total) {
    super();
    set_total(total);
    }
  public static CountingVisitor parse(java.io.Reader in) throws ParseException { return new Parser(in)._CountingVisitor();   }
  public static CountingVisitor parse(java.io.InputStream in) throws ParseException { return new Parser(in)._CountingVisitor();   }
  public static CountingVisitor parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
    }
  public CountingVisitor() { total = 0;   }
  public void before(Vertex host) { total = total +1;   }
  public void after(Cd_graph host) { System.out.println("CountingVisitor is leaving " +host.getClass().toString() + " total = " + total);   }
  public void after(Adj host) { System.out.println("CountingVisitor is leaving " +host.getClass().toString() + " total = " + total);   }
   int get_return_val() { return total ;   }
    void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
  }

    void universal_trv0_aft(UniversalVisitor _v_) {
    super.universal_trv0_aft(_v_);
  }

    void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

}
