import edu.neu.ccs.demeter.*;
 class DisplayVisitor extends UniversalVisitor {
  protected int indent;
  public int get_indent() { return indent;   }
  public void set_indent(int new_indent) { indent = new_indent;   }
  public DisplayVisitor() { super();   }
  public DisplayVisitor(int indent) {
    super();
    set_indent(indent);
    }
  
    protected java.io.PrintWriter out = new java.io.PrintWriter(System.out, true);
    java.io.PrintWriter get_out()             { return out; }
    void set_out(java.io.PrintWriter new_out) { out = new_out; }
    DisplayVisitor(java.io.PrintWriter out)     { set_out(out); }
    DisplayVisitor(java.io.PrintStream out)
      { set_out(new java.io.PrintWriter(out, true)); }
  
  public void finish() { out.flush();   }
  public void before(Cd_graph host) {
    out.print(": Cd_graph  (");
    indent++;
    }
  public void after(Cd_graph host) {
    out.print(" )");
    indent--;
    }
  public void before_first(Cd_graph source, Adj dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<first> ");
    }
  public void before_rest(Cd_graph source, Adj_list dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<rest> ");
    }
  public void before(Adj host) {
    out.print(": Adj  (");
    indent++;
    }
  public void after(Adj host) {
    out.print(" )");
    indent--;
    }
  public void before_vertex(Adj source, Vertex dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<vertex> ");
    }
  public void before_ns(Adj source, Neighbors dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<ns> ");
    }
  public void before(Construct host) {
    out.print(": Construct  (");
    indent++;
    }
  public void after(Construct host) {
    out.print(" )");
    indent--;
    }
  public void before_c_ns(Construct source, Any_vertex_list dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<c_ns> ");
    }
  public void before(Alternat host) {
    out.print(": Alternat  (");
    indent++;
    }
  public void after(Alternat host) {
    out.print(" )");
    indent--;
    }
  public void before_first(Alternat source, Vertex dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<first> ");
    }
  public void before_second(Alternat source, Vertex dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<second> ");
    }
  public void before(Syntax_vertex host) {
    out.print(": Syntax_vertex  (");
    indent++;
    }
  public void after(Syntax_vertex host) {
    out.print(" )");
    indent--;
    }
  public void before_string(Syntax_vertex source, String dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<string> ");
    out.print(" : String");
    out.print(" \"" + source.get_string() + "\" ");
    }
  public void before(Labeled_vertex host) {
    out.print(": Labeled_vertex  (");
    indent++;
    }
  public void after(Labeled_vertex host) {
    out.print(" )");
    indent--;
    }
  public void before_label_name(Labeled_vertex source, Ident dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<label_name> ");
    out.print(" : Ident");
    out.print(" \"" + source.get_label_name() + "\"");
    }
  public void before_class_name(Labeled_vertex source, Vertex dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<class_name> ");
    }
  public void before(Nany_vertex_list host) {
    out.print(": Nany_vertex_list  (");
    indent++;
    }
  public void after(Nany_vertex_list host) {
    out.print(" )");
    indent--;
    }
  public void before_first(Nany_vertex_list source, Any_vertex dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<first> ");
    }
  public void before_rest(Nany_vertex_list source, Any_vertex_list dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<rest> ");
    }
  public void before(Empty host) {
    out.print(": Empty  (");
    indent++;
    }
  public void after(Empty host) {
    out.print(" )");
    indent--;
    }
  public void before(Empty_cd_graph host) {
    out.print(": Empty_cd_graph  (");
    indent++;
    }
  public void after(Empty_cd_graph host) {
    out.print(" )");
    indent--;
    }
  public void before(Vertex host) {
    out.print(": Vertex  (");
    indent++;
    }
  public void after(Vertex host) {
    out.print(" )");
    indent--;
    }
  public void before_name(Vertex source, Ident dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<name> ");
    out.print(" : Ident");
    out.print(" \"" + source.get_name() + "\"");
    }
  public void before(CountingVisitor host) {
    out.print(": CountingVisitor  (");
    indent++;
    }
  public void after(CountingVisitor host) {
    out.print(" )");
    indent--;
    }
  public void before_total(CountingVisitor source, int dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<total> ");
    out.print(" : int \"" + dest + "\"");
    }
  public void before(Main host) {
    out.print(": Main  (");
    indent++;
    }
  public void after(Main host) {
    out.print(" )");
    indent--;
    }
  public void before(PrintVisitor host) {
    out.print(": PrintVisitor  (");
    indent++;
    }
  public void after(PrintVisitor host) {
    out.print(" )");
    indent--;
    }
  public void before_indent(PrintVisitor source, int dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<indent> ");
    out.print(" : int \"" + dest + "\"");
    }
  public void before_needSpace(PrintVisitor source, boolean dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<needSpace> ");
    out.print(" : boolean \"" + dest + "\"");
    }
  public void before(CopyVisitor host) {
    out.print(": CopyVisitor  (");
    indent++;
    }
  public void after(CopyVisitor host) {
    out.print(" )");
    indent--;
    }
  public void before_copy(CopyVisitor source, Object dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<copy> ");
    }
  public void before(SubgraphVisitor host) {
    out.print(": SubgraphVisitor  (");
    indent++;
    }
  public void after(SubgraphVisitor host) {
    out.print(" )");
    indent--;
    }
  public void before_is_equal(SubgraphVisitor source, boolean dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<is_equal> ");
    out.print(" : boolean \"" + dest + "\"");
    }
  public void before(EqualVisitor host) {
    out.print(": EqualVisitor  (");
    indent++;
    }
  public void after(EqualVisitor host) {
    out.print(" )");
    indent--;
    }
  public void before_is_equal(EqualVisitor source, boolean dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<is_equal> ");
    out.print(" : boolean \"" + dest + "\"");
    }
  public void before(DisplayVisitor host) {
    out.print(": DisplayVisitor  (");
    indent++;
    }
  public void after(DisplayVisitor host) {
    out.print(" )");
    indent--;
    }
  public void before_indent(DisplayVisitor source, int dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<indent> ");
    out.print(" : int \"" + dest + "\"");
    }
  public void before(TraceVisitor host) {
    out.print(": TraceVisitor  (");
    indent++;
    }
  public void after(TraceVisitor host) {
    out.print(" )");
    indent--;
    }
  public void before_indent(TraceVisitor source, int dest) {
    out.println();    for (int i = 0; i < indent; i++) out.print("\t");
    out.print("<indent> ");
    out.print(" : int \"" + dest + "\"");
    }
    void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
  }

    void universal_trv0_aft(UniversalVisitor _v_) {
    super.universal_trv0_aft(_v_);
  }

    void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

}
