import edu.neu.ccs.demeter.*;
 class PrintVisitor extends UniversalVisitor {
  protected int indent;
  public int get_indent() { return indent;   }
  public void set_indent(int new_indent) { indent = new_indent;   }
  protected boolean needSpace;
  public boolean get_needSpace() { return needSpace;   }
  public void set_needSpace(boolean new_needSpace) { needSpace = new_needSpace;   }
  public PrintVisitor() { super();   }
  public PrintVisitor(int indent, boolean needSpace) {
    super();
    set_indent(indent);
    set_needSpace(needSpace);
    }
  
    protected java.io.PrintWriter out = new java.io.PrintWriter(System.out, true);
    java.io.PrintWriter get_out()             { return out; }
    void set_out(java.io.PrintWriter new_out) { out = new_out; }
    PrintVisitor(java.io.PrintWriter out)     { set_out(out); }
    PrintVisitor(java.io.PrintStream out)
      { set_out(new java.io.PrintWriter(out, true)); }
  
  public void finish() { out.flush();   }
  protected void space() {
    if (needSpace) out.print(" ");
    needSpace = false;
    }
  public void after_ns(Adj source, Neighbors dest) {
    out.print(".");
    needSpace = false;
    }
  public void before_c_ns(Construct source, Any_vertex_list dest) {
    out.print("=");
    needSpace = false;
    }
  public void before_first(Alternat source, Vertex dest) {
    out.print(":");
    needSpace = false;
    }
  public void before_second(Alternat source, Vertex dest) {
    out.print("|");
    needSpace = false;
    }
  public void before_string(Syntax_vertex source, String dest) {
    space();
    out.print("\"" + source.get_string() + "\"");
    needSpace = true;
    }
  public void before_label_name(Labeled_vertex source, Ident dest) {
    out.print("<");
    needSpace = false;
    space();
    out.print(source.get_label_name());
    needSpace = true;
    }
  public void before_class_name(Labeled_vertex source, Vertex dest) {
    out.print(">");
    needSpace = false;
    }
  public void before_name(Vertex source, Ident dest) {
    space();
    out.print(source.get_name());
    needSpace = true;
    }
  public void before_total(CountingVisitor source, int dest) {
    space();
    out.print(source.get_total());
    needSpace = true;
    }
  public void before_indent(PrintVisitor source, int dest) {
    space();
    out.print(source.get_indent());
    needSpace = true;
    }
  public void before_needSpace(PrintVisitor source, boolean dest) {
    space();
    out.print(source.get_needSpace());
    needSpace = true;
    }
  public void before_copy(CopyVisitor source, Object dest) {
    space();
    out.print(source.get_copy());
    needSpace = true;
    }
  public void before_is_equal(SubgraphVisitor source, boolean dest) {
    space();
    out.print(source.get_is_equal());
    needSpace = true;
    }
  public void before_is_equal(EqualVisitor source, boolean dest) {
    space();
    out.print(source.get_is_equal());
    needSpace = true;
    }
  public void before_indent(DisplayVisitor source, int dest) {
    space();
    out.print(source.get_indent());
    needSpace = true;
    }
  public void before_indent(TraceVisitor source, int dest) {
    space();
    out.print(source.get_indent());
    needSpace = true;
    }
    void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
  }

    void universal_trv0_aft(UniversalVisitor _v_) {
    super.universal_trv0_aft(_v_);
  }

    void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

}
