import edu.neu.ccs.demeter.*;
 class TraceVisitor extends UniversalVisitor {
  protected int indent;
  public int get_indent() { return indent;   }
  public void set_indent(int new_indent) { indent = new_indent;   }
  public TraceVisitor() { super();   }
  public TraceVisitor(int indent) {
    super();
    set_indent(indent);
    }
  
    protected java.io.PrintWriter out = new java.io.PrintWriter(System.out, true);
    java.io.PrintWriter get_out()             { return out; }
    void set_out(java.io.PrintWriter new_out) { out = new_out; }
    TraceVisitor(java.io.PrintWriter out)     { set_out(out); }
    TraceVisitor(java.io.PrintStream out)
      { set_out(new java.io.PrintWriter(out, true)); }
  
  public void finish() { out.flush();   }
  public void before(Cd_graph host) {
    out.println("before Cd_graph");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Cd_graph host) {
    out.println("after Cd_graph");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_first(Cd_graph source, Adj dest) {
    out.println("before -> Cd_graph, first, Adj ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_first(Cd_graph source, Adj dest) {
    out.println("after -> Cd_graph, first, Adj ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_rest(Cd_graph source, Adj_list dest) {
    out.println("before -> Cd_graph, rest, Adj_list ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_rest(Cd_graph source, Adj_list dest) {
    out.println("after -> Cd_graph, rest, Adj_list ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Adj host) {
    out.println("before Adj");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Adj host) {
    out.println("after Adj");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_vertex(Adj source, Vertex dest) {
    out.println("before -> Adj, vertex, Vertex ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_vertex(Adj source, Vertex dest) {
    out.println("after -> Adj, vertex, Vertex ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_ns(Adj source, Neighbors dest) {
    out.println("before -> Adj, ns, Neighbors ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_ns(Adj source, Neighbors dest) {
    out.println("after -> Adj, ns, Neighbors ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Neighbors host) {
    out.println("before Neighbors");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Neighbors host) {
    out.println("after Neighbors");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Construct host) {
    out.println("before Construct");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Construct host) {
    out.println("after Construct");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_c_ns(Construct source, Any_vertex_list dest) {
    out.println("before -> Construct, c_ns, Any_vertex_list ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_c_ns(Construct source, Any_vertex_list dest) {
    out.println("after -> Construct, c_ns, Any_vertex_list ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Alternat host) {
    out.println("before Alternat");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Alternat host) {
    out.println("after Alternat");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_first(Alternat source, Vertex dest) {
    out.println("before -> Alternat, first, Vertex ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_first(Alternat source, Vertex dest) {
    out.println("after -> Alternat, first, Vertex ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_second(Alternat source, Vertex dest) {
    out.println("before -> Alternat, second, Vertex ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_second(Alternat source, Vertex dest) {
    out.println("after -> Alternat, second, Vertex ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Any_vertex host) {
    out.println("before Any_vertex");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Any_vertex host) {
    out.println("after Any_vertex");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Syntax_vertex host) {
    out.println("before Syntax_vertex");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Syntax_vertex host) {
    out.println("after Syntax_vertex");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_string(Syntax_vertex source, String dest) {
    out.println("before -> Syntax_vertex, string, String ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_string(Syntax_vertex source, String dest) {
    out.println("after -> Syntax_vertex, string, String ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Labeled_vertex host) {
    out.println("before Labeled_vertex");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Labeled_vertex host) {
    out.println("after Labeled_vertex");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_label_name(Labeled_vertex source, Ident dest) {
    out.println("before -> Labeled_vertex, label_name, Ident ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_label_name(Labeled_vertex source, Ident dest) {
    out.println("after -> Labeled_vertex, label_name, Ident ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_class_name(Labeled_vertex source, Vertex dest) {
    out.println("before -> Labeled_vertex, class_name, Vertex ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_class_name(Labeled_vertex source, Vertex dest) {
    out.println("after -> Labeled_vertex, class_name, Vertex ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Adj_list host) {
    out.println("before Adj_list");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Adj_list host) {
    out.println("after Adj_list");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Any_vertex_list host) {
    out.println("before Any_vertex_list");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Any_vertex_list host) {
    out.println("after Any_vertex_list");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Nany_vertex_list host) {
    out.println("before Nany_vertex_list");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Nany_vertex_list host) {
    out.println("after Nany_vertex_list");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_first(Nany_vertex_list source, Any_vertex dest) {
    out.println("before -> Nany_vertex_list, first, Any_vertex ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_first(Nany_vertex_list source, Any_vertex dest) {
    out.println("after -> Nany_vertex_list, first, Any_vertex ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_rest(Nany_vertex_list source, Any_vertex_list dest) {
    out.println("before -> Nany_vertex_list, rest, Any_vertex_list ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_rest(Nany_vertex_list source, Any_vertex_list dest) {
    out.println("after -> Nany_vertex_list, rest, Any_vertex_list ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Empty host) {
    out.println("before Empty");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Empty host) {
    out.println("after Empty");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Empty_cd_graph host) {
    out.println("before Empty_cd_graph");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Empty_cd_graph host) {
    out.println("after Empty_cd_graph");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Vertex host) {
    out.println("before Vertex");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Vertex host) {
    out.println("after Vertex");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_name(Vertex source, Ident dest) {
    out.println("before -> Vertex, name, Ident ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_name(Vertex source, Ident dest) {
    out.println("after -> Vertex, name, Ident ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(CountingVisitor host) {
    out.println("before CountingVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(CountingVisitor host) {
    out.println("after CountingVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_total(CountingVisitor source, int dest) {
    out.println("before -> CountingVisitor, total, int ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_total(CountingVisitor source, int dest) {
    out.println("after -> CountingVisitor, total, int ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Main host) {
    out.println("before Main");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Main host) {
    out.println("after Main");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(PrintVisitor host) {
    out.println("before PrintVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(PrintVisitor host) {
    out.println("after PrintVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_indent(PrintVisitor source, int dest) {
    out.println("before -> PrintVisitor, indent, int ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_indent(PrintVisitor source, int dest) {
    out.println("after -> PrintVisitor, indent, int ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_needSpace(PrintVisitor source, boolean dest) {
    out.println("before -> PrintVisitor, needSpace, boolean ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_needSpace(PrintVisitor source, boolean dest) {
    out.println("after -> PrintVisitor, needSpace, boolean ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(CopyVisitor host) {
    out.println("before CopyVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(CopyVisitor host) {
    out.println("after CopyVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_copy(CopyVisitor source, Object dest) {
    out.println("before -> CopyVisitor, copy, Object ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_copy(CopyVisitor source, Object dest) {
    out.println("after -> CopyVisitor, copy, Object ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(SubgraphVisitor host) {
    out.println("before SubgraphVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(SubgraphVisitor host) {
    out.println("after SubgraphVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_is_equal(SubgraphVisitor source, boolean dest) {
    out.println("before -> SubgraphVisitor, is_equal, boolean ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_is_equal(SubgraphVisitor source, boolean dest) {
    out.println("after -> SubgraphVisitor, is_equal, boolean ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(EqualVisitor host) {
    out.println("before EqualVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(EqualVisitor host) {
    out.println("after EqualVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_is_equal(EqualVisitor source, boolean dest) {
    out.println("before -> EqualVisitor, is_equal, boolean ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_is_equal(EqualVisitor source, boolean dest) {
    out.println("after -> EqualVisitor, is_equal, boolean ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(DisplayVisitor host) {
    out.println("before DisplayVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(DisplayVisitor host) {
    out.println("after DisplayVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_indent(DisplayVisitor source, int dest) {
    out.println("before -> DisplayVisitor, indent, int ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_indent(DisplayVisitor source, int dest) {
    out.println("after -> DisplayVisitor, indent, int ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(TraceVisitor host) {
    out.println("before TraceVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(TraceVisitor host) {
    out.println("after TraceVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_indent(TraceVisitor source, int dest) {
    out.println("before -> TraceVisitor, indent, int ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_indent(TraceVisitor source, int dest) {
    out.println("after -> TraceVisitor, indent, int ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(UniversalVisitor host) {
    out.println("before UniversalVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(UniversalVisitor host) {
    out.println("after UniversalVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
    void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
  }

    void universal_trv0_aft(UniversalVisitor _v_) {
    super.universal_trv0_aft(_v_);
  }

    void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

}
