import edu.neu.ccs.demeter.*;
 class EqualVisitor extends UniversalVisitor {
  protected boolean is_equal =  true ;
  public boolean get_is_equal() { return is_equal;   }
  public void set_is_equal(boolean new_is_equal) { is_equal = new_is_equal;   }
  public EqualVisitor() { super();   }
  public EqualVisitor(boolean is_equal) {
    super();
    set_is_equal(is_equal);
    }
  
    private java.util.Stack history = new java.util.Stack();
    public EqualVisitor(Object obj) {
      history.push(obj);
    }
  
  public void before_tree(Example source, Tree dest) {
    if (is_equal) {
      Example obj = (Example) history.peek();
      Object temp1 = obj.get_tree();
      if(temp1==null) { is_equal = false; return; }
      history.push(temp1);
    }
    }
  public void after_tree(Example source, Tree dest) {
    if (is_equal) history.pop();
    }
  public void before(Example host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    }
  public void before_l(Tree source, Label dest) {
    if (is_equal) {
      Tree obj = (Tree) history.peek();
      Object temp2 = obj.get_l();
      if(temp2==null) { is_equal = false; return; }
      history.push(temp2);
    }
    }
  public void after_l(Tree source, Label dest) {
    if (is_equal) history.pop();
    }
  public void before_left(Tree source, Tree dest) {
    if (is_equal) {
      Tree obj = (Tree) history.peek();
      Object temp3 = obj.get_left();
      if(temp3==null) { is_equal = false; return; }
      history.push(temp3);
    }
    }
  public void after_left(Tree source, Tree dest) {
    if (is_equal) history.pop();
    }
  public void before_right(Tree source, Tree dest) {
    if (is_equal) {
      Tree obj = (Tree) history.peek();
      Object temp4 = obj.get_right();
      if(temp4==null) { is_equal = false; return; }
      history.push(temp4);
    }
    }
  public void after_right(Tree source, Tree dest) {
    if (is_equal) history.pop();
    }
  public void before(Tree host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    }
  public void before(Label host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_v() == ((Label) obj).get_v();
    }
  public void before(SummingVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_total() == ((SummingVisitor) obj).get_total();
    }
  public void before(SummingVisitor2 host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_total() == ((SummingVisitor2) obj).get_total();
    }
  public void before(Main host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    }
  public void before(PrintVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_indent() == ((PrintVisitor) obj).get_indent();
    is_equal = is_equal && host.get_needSpace() == ((PrintVisitor) obj).get_needSpace();
    }
  public void before(CopyVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    Object temp5 = host.get_copy();
    Object temp6 = ((CopyVisitor) obj).get_copy();
    if(temp5 == null && temp6 == null) {}
    else if(temp5 == null ||
            temp6 == null ||
            !temp5.equals(temp6)) { is_equal = false; return; }
    }
  public void before(SubgraphVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_is_equal() == ((SubgraphVisitor) obj).get_is_equal();
    }
  public void before(EqualVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_is_equal() == ((EqualVisitor) obj).get_is_equal();
    }
  public void before(DisplayVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_indent() == ((DisplayVisitor) obj).get_indent();
    }
  public void before(TraceVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_indent() == ((TraceVisitor) obj).get_indent();
    }
  public void before(UniversalVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    }
   boolean get_return_val() { return is_equal ;   }
    void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
  }

    void universal_trv0_aft(UniversalVisitor _v_) {
    super.universal_trv0_aft(_v_);
  }

    void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

}
