import edu.neu.ccs.demeter.*;
 class Tree {
  protected Label l;
  public Label get_l() { return l;   }
  public void set_l(Label new_l) { l = new_l;   }
  protected Tree left;
  public Tree get_left() { return left;   }
  public void set_left(Tree new_left) { left = new_left;   }
  protected Tree right;
  public Tree get_right() { return right;   }
  public void set_right(Tree new_right) { right = new_right;   }
  public Tree() { super();   }
  public Tree(Label l, Tree left, Tree right) {
    super();
    set_l(l);
    set_left(left);
    set_right(right);
    }
  public static Tree parse(java.io.Reader in) throws ParseException { return new Parser(in)._Tree();   }
  public static Tree parse(java.io.InputStream in) throws ParseException { return new Parser(in)._Tree();   }
  public static Tree parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
    }
  
  int sum_labels() throws Exception {
    SummingVisitor s = SummingVisitor.parse("0");
    this.allLabels(s, new TraceVisitor());
    return s.get_total();}
  
  // int sum_labels2() = allLabels2(SummingVisitor2, DisplayVisitor);
  int sum_labels2(){
	  SummingVisitor2 s = new SummingVisitor2();
	  DisplayVisitor d = new DisplayVisitor();
	  this.allLabels2(s,d);
	  d.finish(); // to flush the printing buffer
	  return s.get_total();}
  
   void print_leftTrees() {
    DisplayVisitor v0 = new DisplayVisitor();
    v0.start();
    leftTrees(v0);
    v0.finish();
    }
   void print_allTrees() {
    DisplayVisitor v0 = new DisplayVisitor();
    v0.start();
    allTrees(v0);
    v0.finish();
    }
    void universal_trv0_bef(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).before(this);
  }

    void universal_trv0_aft(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).after(this);
  }

    void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before_l(this, l);
    l.universal_trv0(_v_);
    ((UniversalVisitor) _v_).after_l(this, l);
    if (left != null) {
      ((UniversalVisitor) _v_).before_left(this, left);
      left.universal_trv0(_v_);
      ((UniversalVisitor) _v_).after_left(this, left);
    }
    if (right != null) {
      ((UniversalVisitor) _v_).before_right(this, right);
      right.universal_trv0(_v_);
      ((UniversalVisitor) _v_).after_right(this, right);
    }
    universal_trv0_aft(_v_);
  }

    public void allLabels(SummingVisitor __v0, UniversalVisitor __v1) {
    allLabels_Tree_trv(__v0, __v1);
  }

    void allLabels_Tree_trv_bef(SummingVisitor __v0, UniversalVisitor __v1) {
    ((UniversalVisitor) __v1).before(this);
  }

    void allLabels_Tree_trv_aft(SummingVisitor __v0, UniversalVisitor __v1) {
    ((UniversalVisitor) __v1).after(this);
  }

    void allLabels_Tree_trv(SummingVisitor __v0, UniversalVisitor __v1) {
    allLabels_Tree_trv_bef(__v0, __v1);
    ((UniversalVisitor) __v1).before_l(this, l);
    l.allLabels_Tree_trv(__v0, __v1);
    ((UniversalVisitor) __v1).after_l(this, l);
    if (left != null) {
      ((UniversalVisitor) __v1).before_left(this, left);
      left.allLabels_Tree_trv(__v0, __v1);
      ((UniversalVisitor) __v1).after_left(this, left);
    }
    if (right != null) {
      ((UniversalVisitor) __v1).before_right(this, right);
      right.allLabels_Tree_trv(__v0, __v1);
      ((UniversalVisitor) __v1).after_right(this, right);
    }
    allLabels_Tree_trv_aft(__v0, __v1);
  }

    public void allLabels2(SummingVisitor2 __v0, UniversalVisitor __v1) {
    allLabels2_Tree_trv(__v0, __v1);
  }

    void allLabels2_Tree_trv_bef(SummingVisitor2 __v0, UniversalVisitor __v1) {
    ((UniversalVisitor) __v1).before(this);
  }

    void allLabels2_Tree_trv_aft(SummingVisitor2 __v0, UniversalVisitor __v1) {
    ((UniversalVisitor) __v1).after(this);
  }

    void allLabels2_Tree_trv(SummingVisitor2 __v0, UniversalVisitor __v1) {
    allLabels2_Tree_trv_bef(__v0, __v1);
    ((UniversalVisitor) __v1).before_l(this, l);
    l.allLabels2_Tree_trv(__v0, __v1);
    ((UniversalVisitor) __v1).after_l(this, l);
    if (left != null) {
      ((UniversalVisitor) __v1).before_left(this, left);
      left.allLabels2_Tree_trv(__v0, __v1);
      ((UniversalVisitor) __v1).after_left(this, left);
    }
    if (right != null) {
      ((UniversalVisitor) __v1).before_right(this, right);
      right.allLabels2_Tree_trv(__v0, __v1);
      ((UniversalVisitor) __v1).after_right(this, right);
    }
    allLabels2_Tree_trv_aft(__v0, __v1);
  }

    public void leftTrees(UniversalVisitor __v0) {
    leftTrees_Tree_trv(__v0);
  }

    void leftTrees_Tree_trv_bef(UniversalVisitor __v0) {
    ((UniversalVisitor) __v0).before(this);
  }

    void leftTrees_Tree_trv_aft(UniversalVisitor __v0) {
    ((UniversalVisitor) __v0).after(this);
  }

    void leftTrees_Tree_trv(UniversalVisitor __v0) {
    leftTrees_Tree_trv_bef(__v0);
    if (left != null) {
      ((UniversalVisitor) __v0).before_left(this, left);
      left.leftTrees_Tree_trv(__v0);
      ((UniversalVisitor) __v0).after_left(this, left);
    }
    leftTrees_Tree_trv_aft(__v0);
  }

    public void allTrees(UniversalVisitor __v0) {
    allTrees_Tree_trv(__v0);
  }

    void allTrees_Tree_trv_bef(UniversalVisitor __v0) {
    ((UniversalVisitor) __v0).before(this);
  }

    void allTrees_Tree_trv_aft(UniversalVisitor __v0) {
    ((UniversalVisitor) __v0).after(this);
  }

    void allTrees_Tree_trv(UniversalVisitor __v0) {
    allTrees_Tree_trv_bef(__v0);
    if (left != null) {
      ((UniversalVisitor) __v0).before_left(this, left);
      left.allTrees_Tree_trv(__v0);
      ((UniversalVisitor) __v0).after_left(this, left);
    }
    if (right != null) {
      ((UniversalVisitor) __v0).before_right(this, right);
      right.allTrees_Tree_trv(__v0);
      ((UniversalVisitor) __v0).after_right(this, right);
    }
    allTrees_Tree_trv_aft(__v0);
  }

}
