import edu.neu.ccs.demeter.*;
 class SubgraphVisitor extends UniversalVisitor {
  protected boolean is_equal =  true ;
  public boolean get_is_equal() { return is_equal;   }
  public void set_is_equal(boolean new_is_equal) { is_equal = new_is_equal;   }
  public SubgraphVisitor() { super();   }
  public SubgraphVisitor(boolean is_equal) {
    super();
    set_is_equal(is_equal);
    }
  
    private java.util.Stack history = new java.util.Stack();
    public SubgraphVisitor(Object obj) {
      history.push(obj);
    }
  
  public void before_first(Cd_graph source, Adj dest) {
    if (is_equal) {
      Cd_graph obj = (Cd_graph) history.peek();
      Object temp1 = obj.get_first();
      if(temp1==null) { is_equal = false; return; }
      history.push(temp1);
    }
    }
  public void after_first(Cd_graph source, Adj dest) {
    if (is_equal) history.pop();
    }
  public void before_rest(Cd_graph source, Adj_list dest) {
    if (is_equal) {
      Cd_graph obj = (Cd_graph) history.peek();
      Object temp2 = obj.get_rest();
      if(temp2==null) { is_equal = false; return; }
      history.push(temp2);
    }
    }
  public void after_rest(Cd_graph source, Adj_list dest) {
    if (is_equal) history.pop();
    }
  public void before(Cd_graph host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    }
  public void before_vertex(Adj source, Vertex dest) {
    if (is_equal) {
      Adj obj = (Adj) history.peek();
      Object temp3 = obj.get_vertex();
      if(temp3==null) { is_equal = false; return; }
      history.push(temp3);
    }
    }
  public void after_vertex(Adj source, Vertex dest) {
    if (is_equal) history.pop();
    }
  public void before_ns(Adj source, Neighbors dest) {
    if (is_equal) {
      Adj obj = (Adj) history.peek();
      Object temp4 = obj.get_ns();
      if(temp4==null) { is_equal = false; return; }
      history.push(temp4);
    }
    }
  public void after_ns(Adj source, Neighbors dest) {
    if (is_equal) history.pop();
    }
  public void before(Adj host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    }
  public void before(Neighbors host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    }
  public void before_c_ns(Construct source, Any_vertex_list dest) {
    if (is_equal) {
      Construct obj = (Construct) history.peek();
      Object temp5 = obj.get_c_ns();
      if(temp5==null) { is_equal = false; return; }
      history.push(temp5);
    }
    }
  public void after_c_ns(Construct source, Any_vertex_list dest) {
    if (is_equal) history.pop();
    }
  public void before(Construct host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    }
  public void before_first(Alternat source, Vertex dest) {
    if (is_equal) {
      Alternat obj = (Alternat) history.peek();
      Object temp6 = obj.get_first();
      if(temp6==null) { is_equal = false; return; }
      history.push(temp6);
    }
    }
  public void after_first(Alternat source, Vertex dest) {
    if (is_equal) history.pop();
    }
  public void before_second(Alternat source, Vertex dest) {
    if (is_equal) {
      Alternat obj = (Alternat) history.peek();
      Object temp7 = obj.get_second();
      if(temp7==null) { is_equal = false; return; }
      history.push(temp7);
    }
    }
  public void after_second(Alternat source, Vertex dest) {
    if (is_equal) history.pop();
    }
  public void before(Alternat host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    }
  public void before(Any_vertex host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    }
  public void before(Syntax_vertex host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    Object temp8 = host.get_string();
    Object temp9 = ((Syntax_vertex) obj).get_string();
    if(temp8 == null && temp9 == null) {}
    else if(temp8 == null ||
            temp9 == null ||
            !temp8.equals(temp9)) { is_equal = false; return; }
    }
  public void before_class_name(Labeled_vertex source, Vertex dest) {
    if (is_equal) {
      Labeled_vertex obj = (Labeled_vertex) history.peek();
      Object temp12 = obj.get_class_name();
      if(temp12==null) { is_equal = false; return; }
      history.push(temp12);
    }
    }
  public void after_class_name(Labeled_vertex source, Vertex dest) {
    if (is_equal) history.pop();
    }
  public void before(Labeled_vertex host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    Object temp10 = host.get_label_name();
    Object temp11 = ((Labeled_vertex) obj).get_label_name();
    if(temp10 == null && temp11 == null) {}
    else if(temp10 == null ||
            temp11 == null ||
            !temp10.equals(temp11)) { is_equal = false; return; }
    }
  public void before(Adj_list host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    }
  public void before(Any_vertex_list host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    }
  public void before_first(Nany_vertex_list source, Any_vertex dest) {
    if (is_equal) {
      Nany_vertex_list obj = (Nany_vertex_list) history.peek();
      Object temp13 = obj.get_first();
      if(temp13==null) { is_equal = false; return; }
      history.push(temp13);
    }
    }
  public void after_first(Nany_vertex_list source, Any_vertex dest) {
    if (is_equal) history.pop();
    }
  public void before_rest(Nany_vertex_list source, Any_vertex_list dest) {
    if (is_equal) {
      Nany_vertex_list obj = (Nany_vertex_list) history.peek();
      Object temp14 = obj.get_rest();
      if(temp14==null) { is_equal = false; return; }
      history.push(temp14);
    }
    }
  public void after_rest(Nany_vertex_list source, Any_vertex_list dest) {
    if (is_equal) history.pop();
    }
  public void before(Nany_vertex_list host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    }
  public void before(Empty host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    }
  public void before(Empty_cd_graph host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    }
  public void before(Vertex host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    Object temp15 = host.get_name();
    Object temp16 = ((Vertex) obj).get_name();
    if(temp15 == null && temp16 == null) {}
    else if(temp15 == null ||
            temp16 == null ||
            !temp15.equals(temp16)) { is_equal = false; return; }
    }
  public void before(CountingVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_total() == ((CountingVisitor) obj).get_total();
    }
  public void before(Main host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    }
  public void before(PrintVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_indent() == ((PrintVisitor) obj).get_indent();
    is_equal = is_equal && host.get_needSpace() == ((PrintVisitor) obj).get_needSpace();
    }
  public void before(CopyVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    Object temp17 = host.get_copy();
    Object temp18 = ((CopyVisitor) obj).get_copy();
    if(temp17 == null && temp18 == null) {}
    else if(temp17 == null ||
            temp18 == null ||
            !temp17.equals(temp18)) { is_equal = false; return; }
    }
  public void before(SubgraphVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_is_equal() == ((SubgraphVisitor) obj).get_is_equal();
    }
  public void before(EqualVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_is_equal() == ((EqualVisitor) obj).get_is_equal();
    }
  public void before(DisplayVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_indent() == ((DisplayVisitor) obj).get_indent();
    }
  public void before(TraceVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_indent() == ((TraceVisitor) obj).get_indent();
    }
  public void before(UniversalVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    }
   boolean get_return_val() { return is_equal ;   }
    void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
  }

    void universal_trv0_aft(UniversalVisitor _v_) {
    super.universal_trv0_aft(_v_);
  }

    void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

}
